include masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WND_DATA struct
	factor	REAL4	?
	sign	REAL4	?
	hdc		HDC		?
	bmp		HBITMAP	?
	hdc2	HDC		?
	bmp2	HBITMAP	?
WND_DATA ends

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL xfrm:XFORM
LOCAL factor:REAL4
LOCAL rect:RECT
LOCAL sign:REAL4

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		invoke DeleteObject,rv(SelectObject,ebx,rv(GetWindowLong,hWnd,WND_DATA.bmp))
		invoke DeleteDC,ebx
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc2)
		invoke DeleteObject,rv(SelectObject,ebx,rv(GetWindowLong,hWnd,WND_DATA.bmp2))
		invoke DeleteDC,ebx
	.elseif uMsg == WM_CREATE
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke SetWindowLong,hWnd,WND_DATA.bmp,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		invoke BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATCOPY
		invoke SetGraphicsMode,ebx,GM_ADVANCED
		
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
;;  		.if CHAR ptr [OpenFileDlg(hWnd,hInstance,"select bitmap",chr$("bitmaps",0,"*.bmp",0,0))]
;;			.if !rv(LoadImage,0,eax,IMAGE_BITMAP,0,0,LR_LOADFROMFILE or LR_DEFAULTSIZE)
;;				invoke MessageBeep,0FFFFFFFFh
;;				invoke ExitProcess,0
;;			.endif
;;			invoke SetWindowLong,hWnd,WND_DATA.bmp2,rv(SelectObject,ebx,eax)
;;		.else
;;			invoke MessageBeep,0FFFFFFFFh
;;			invoke ExitProcess,0
;;		.endif
		invoke SetWindowLong,hWnd,WND_DATA.bmp2,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke BitBlt,ebx,0,0,10000,10000,ebx,0,0,PATCOPY ;;
		invoke SetWindowLong,hWnd,WND_DATA.hdc2,ebx
		invoke SetGraphicsMode,ebx,GM_ADVANCED

		invoke MoveToEx,ebx,0,0,0
		invoke LineTo,ebx,100,100
		invoke LineTo,ebx,0,100
		invoke LineTo,ebx,100,0
		invoke LineTo,ebx,0,0
		invoke LineTo,ebx,0,100
		invoke MoveToEx,ebx,100,0,0
		invoke LineTo,ebx,100,100
		
		invoke SetWindowLong,hWnd,WND_DATA.factor,FP4(0.5)
		invoke SetWindowLong,hWnd,WND_DATA.sign,FP4(-1.0)
		
		invoke SetTimer,hWnd,100,100,0
		
	.elseif uMsg == WM_TIMER
		.if wParam == 100
			invoke GetClientRect,hWnd,ADDR rect
			mov factor,rv(GetWindowLong,hWnd,WND_DATA.factor)
			mov sign,rv(GetWindowLong,hWnd,WND_DATA.sign)
			mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
			mov esi,rv(GetWindowLong,hWnd,WND_DATA.hdc2)
			invoke BitBlt,ebx,0,0,rect.right,rect.bottom,ebx,0,0,PATCOPY
			
			m2m xfrm.eM11,factor
			m2m xfrm.eM22,factor
			mov xfrm.eM12,0
			mov xfrm.eM21,0
			mov xfrm.ex,0
			mov xfrm.ey,0
			
			invoke SetWorldTransform,esi,ADDR xfrm
			invoke BitBlt,ebx,0,0,rect.right,rect.bottom,esi,0,0,SRCCOPY
			
			fld FP4(1.5)
			fld factor
			fcomip st,st(1)
			fstp st
			.if !CARRY?
				fld sign
				fchs
				fstp sign
			.endif
			
			fld factor
			fld FP4(0.5)
			fcomip st,st(1)
			fstp st
			.if !CARRY?
				fld sign
				fchs
				fstp sign
			.endif
			
			fld factor
			fld FP4(0.08)
			fmul sign
			faddp st(1),st
			fstp factor
			invoke SetWindowLong,hWnd,WND_DATA.factor,factor
			invoke SetWindowLong,hWnd,WND_DATA.sign,sign
			invoke InvalidateRect,hWnd,0,0
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
